package com.nisum.ecomcustomer.config.mongodb;

import com.nisum.ecomcustomer.model.AddressType;
import com.nisum.ecomcustomer.model.CustomerType;
import org.springframework.core.convert.converter.Converter;
import org.springframework.data.convert.ReadingConverter;
import org.springframework.data.convert.WritingConverter;

public class CustomMongoConverters {

    private CustomMongoConverters() {
    }

    @WritingConverter
    static class CustomerTypeToIntegerConverter implements Converter<CustomerType, Integer> {

        @Override
        public Integer convert(CustomerType source) {
            return source.getValue();
        }

    }

    @ReadingConverter
    static class IntegerToCustomerTypeConverter implements Converter<Integer, CustomerType> {

        @Override
        public CustomerType convert(Integer source) {
            return CustomerType.of(source);
        }

    }

    @WritingConverter
    static class AddressTypeToStringConverter implements Converter<AddressType, String> {

        @Override
        public String convert(AddressType source) {
            return source.getValue();
        }

    }

    @ReadingConverter
    static class StringToAddressTypeConverter implements Converter<String, AddressType> {

        @Override
        public AddressType convert(String source) {
            return AddressType.of(source);
        }

    }

}
