package com.nisum.ecomcustomer.model;

import com.fasterxml.jackson.annotation.JsonValue;
import lombok.Getter;

public enum AddressType {
    SHIPPING("ship"),
    BILLING("bill");

    @Getter
    @JsonValue
    private String value;

    @Override
    public String toString() {
        return value;
    }

    AddressType(String value) {
        this.value = value;
    }

    public static AddressType of(String value) {
        switch (value) {
            case "ship":
                return AddressType.SHIPPING;
            case "bill":
                return AddressType.BILLING;
            default:
                throw new IllegalArgumentException(value +" isn't mapped to any AddressType");
        }
    }
}
