package com.nisum.ecomcustomer.model;

import com.fasterxml.jackson.annotation.JsonValue;
import lombok.Getter;

@Getter
public enum CustomerType {
    REGULAR(0),
    LOYAL(1);

    @JsonValue
    private int value;

    CustomerType(int value) {
        this.value = value;
    }

    @Override
    public String toString() {
        return Integer.toString(value);
    }

    public static CustomerType of(int value) {
        switch (value) {
            case 0:
                return CustomerType.REGULAR;
            case 1:
                return CustomerType.LOYAL;
            default:
                throw new IllegalArgumentException(value + " isn't mapped to any CustomerType");
        }
    }
}
