package com.nisum.ecomcustomer.service;

import com.nisum.ecomcustomer.model.Customer;
import com.nisum.ecomcustomer.model.CustomerType;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.util.List;

@Service
public interface CustomerService {
    Customer register(Customer customer);

    List<Customer> registerAll(List<Customer> customers);

    Customer update(Customer customer);

    List<Customer> getAllCustomers();

    Customer getCustomerById(Long id);

    void deleteById(Long id);

    Customer getCustomerByEmail(String email);

    List<Customer> getCustomerByFirstName(String fName);

    List<Customer> getCustomerByLastName(String lName);

    List<Customer> getRegisteredCustomersOnDate(LocalDate onDate);

    List<Customer> getRegisteredCustomersBetweenDates(LocalDate fromDate, LocalDate toDate);

    List<Customer> getCustomersByCustomerType(CustomerType customerType);
}
